#include <stdint.h>
#include "r_meter.h"

//sbits
sbit S1             at GPIO_PIN56_bit;
sbit S2             at GPIO_PIN3_bit;
sbit S3             at GPIO_PIN1_bit;
sbit R_METER_CS     at GPIO_PIN28_bit;

//Prototypes
void system_setup( void );

//Main
void main()
{
    //Local Declarations
    char txt[20] = { 0 };
    float ohms_var = 0;

    //Setup
    system_setup();

    while (1)
    {
        ohms_var = r_meter_get_ohms();
        if( ohms_var == 0 )
            UART1_Write_Text( "Over Range\r\n" );
        else
        {
            FloatToStr( ohms_var, txt );
            UART1_Write_Text( "OHMS: " );
            UART1_Write_Text( txt );
            UART1_Write_Text( "\r\n" );
        }
        delay_ms(250);
    }
}

void system_setup( void )
{
    // GPIOs
    GPIO_Digital_Output( &GPIO_PORT_00_07, _GPIO_PINMASK_3 | _GPIO_PINMASK_1 );
    GPIO_Digital_Output( &GPIO_PORT_24_31, _GPIO_PINMASK_4 );
    GPIO_Digital_Output( &GPIO_PORT_56_63, _GPIO_PINMASK_0 );

    //UART
    UART1_Init(9600);                      // Initialize UART module at 9600 bps
    Delay_ms(100);                         // Wait for UART module to stabilize
    UART1_Write_Text( "Starting\r\n" );
    //ADC
    //ADC_Init();
    //Delay_ms(200);
    UART1_Write_Text( "UART Initialized\r\n" );
    // SPI
    SPIM1_Init_Advanced( _SPI_MASTER_CLK_RATIO_128, _SPI_CFG_PHASE_CAPTURE_FALLING |
                     _SPI_CFG_POLARITY_IDLE_LOW | _SPI_CFG_SS_AUTO_DISABLE |
                     _SPI_CFG_FIFO_DISABLE, _SPI_SS_LINE_NONE );
    Delay_ms( 200 );
    UART1_Write_Text( "SPI Initialized\r\n" );

    r_meter_init();
    UART1_Write_Text( "R Meter Initialized\r\n" );
}